#include "B4RDefines.h"

namespace B4R
{

    B4RGSM_MQTT* B4RGSM_MQTT::instance = NULL;
    void B4RGSM_MQTT::Initialize(ulong KeepAlive, SubVoid_Void AutoConnectSub, Sub1Void_Void OnConnectSub, SubVoid_StringBArray OnMessageSub)
    {
       rcs = new (backend) GSM_MQTT(KeepAlive);
       this->AutoConnectSub = AutoConnectSub; 
       this->OnConnectSub = OnConnectSub; 
       this->OnMessageSub = OnMessageSub; 
    };

    void B4RGSM_MQTT::AutoConnect(void) 
    {
    const UInt cp = B4R::StackMemory::cp;
    instance->AutoConnectSub();
    B4R::StackMemory::cp = cp;
    };

    void B4RGSM_MQTT::OnConnect(void) 
    {
    const UInt cp = B4R::StackMemory::cp;
    instance->OnConnectSub();
    B4R::StackMemory::cp = cp;
    };

    void B4RGSM_MQTT::OnMessage(char * Topic, int TopicLength, byte * Message, int MessageLength) 
    {
    const UInt cp = B4R::StackMemory::cp;
    B4RString* strTopic = CreateStackMemoryObject(B4RString);
    strTopic->data = Topic;
    ArrayByte* arrMessage = CreateStackMemoryObject(ArrayByte);
    arrMessage->data = Message;
    arrMessage->length = MessageLength;
    instance->OnMessageSub(strTopic, arrMessage);
    B4R::StackMemory::cp = cp;
    };

    void B4RGSM_MQTT::begin()
    {
       rcs->begin();
    };

    void B4RGSM_MQTT::connect(B4RString* ClientIdentifier, byte UserNameFlag, byte PassuintFlag, B4RString* UserName, B4RString* Passuint, byte CleanSession, byte WillFlag, byte WillQoS, byte WillRetain, B4RString* WillTopic, B4RString* WillMessage)
    {
       rcs->connect(ClientIdentifier->data, UserNameFlag, PassuintFlag, UserName->data, Passuint->data, CleanSession, WillFlag, WillQoS, WillRetain, WillTopic->data, WillMessage->data);
    };

    void B4RGSM_MQTT::publish(byte DUP, byte Qos, byte RETAIN, uint MessageID, B4RString* Topic, B4RString* Message)
    {
       rcs->publish(DUP, Qos, RETAIN, MessageID, Topic->data, Message->data);
    };

    void B4RGSM_MQTT::subscribe(byte DUP, uint MessageID, B4RString* SubTopic, byte SubQoS)
    {
       rcs->subscribe(DUP, MessageID, SubTopic->data, SubQoS);
    };

    void B4RGSM_MQTT::unsubscribe(byte DUP, uint MessageID, B4RString* SubTopic)
    {
       rcs->unsubscribe(DUP, MessageID, SubTopic->data);
    };

    void B4RGSM_MQTT::disconnect()
    {
       rcs->disconnect();
    };

    void B4RGSM_MQTT::processing()
    {
       rcs->processing();
    };

    bool B4RGSM_MQTT::available()
    {
       return rcs->available();
    };

    void B4RGSM_MQTT::publishACK(uint MessageID)
    {
       rcs->publishACK(MessageID);
    };

    void B4RGSM_MQTT::publishREC(uint MessageID)
    {
       rcs->publishREC(MessageID);
    };

    void B4RGSM_MQTT::publishREL(byte DUP, uint MessageID)
    {
       rcs->publishREL(DUP, MessageID);
    };

    void B4RGSM_MQTT::publishCOMP(uint MessageID)
    {
       rcs->publishCOMP(MessageID);
    };

    void B4RGSM_MQTT::printMessageType(byte Message)
    {
       rcs->printMessageType(Message);
    };

    void B4RGSM_MQTT::printConnectAck(byte Ack)
    {
       rcs->printConnectAck(Ack);
    };

    byte B4RGSM_MQTT::sendATreply(B4RString* command, B4RString* replystr, ulong waitms)
    {
       return rcs->sendATreply(command->data, replystr->data, waitms);
    };
}


