#pragma once
#include "B4RDefines.h"
#include "GSM_MQTT.h"

    //~Event: AutoConnect()
    //~Event: OnConnect()
    //~Event: OnMessage(Topic As String, Message() As Byte)
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    typedef void (*SubVoid_Void)(void);
    typedef void (*Sub1Void_Void)(void);
    typedef void (*SubVoid_StringBArray)(B4RString* str, Array* barray);
    //~shortname:GSM_MQTT
    class B4RGSM_MQTT
    {
        private:
            static B4RGSM_MQTT* instance;
            uint8_t backend[sizeof(GSM_MQTT)];
            GSM_MQTT* rcs;
            SubVoid_Void AutoConnectSub;
            Sub1Void_Void OnConnectSub;
            SubVoid_StringBArray OnMessageSub;
            static void AutoConnect(void);
            static void OnConnect(void);
            static void OnMessage(char * Topic, int TopicLength, byte * Message, int MessageLength);
        public: 
            void Initialize(ulong KeepAlive, SubVoid_Void AutoConnectSub, Sub1Void_Void OnConnectSub, SubVoid_StringBArray OnMessageSub);
            void begin();
            void connect(B4RString* ClientIdentifier, byte UserNameFlag, byte PassuintFlag, B4RString* UserName, B4RString* Passuint, byte CleanSession, byte WillFlag, byte WillQoS, byte WillRetain, B4RString* WillTopic, B4RString* WillMessage);
            void publish(byte DUP, byte Qos, byte RETAIN, uint MessageID, B4RString* Topic, B4RString* Message);
            void subscribe(byte DUP, uint MessageID, B4RString* SubTopic, byte SubQoS);
            void unsubscribe(byte DUP, uint MessageID, B4RString* SubTopic);
            void disconnect();
            void processing();
            bool available();
            void publishACK(uint MessageID);
            void publishREC(uint MessageID);
            void publishREL(byte DUP, uint MessageID);
            void publishCOMP(uint MessageID);
            void printMessageType(byte Message);
            void printConnectAck(byte Ack);
            byte sendATreply(B4RString* command, B4RString* replystr, ulong waitms);
    };
}
